package com.kuyuntech.cofarcooking.device.sdk.devmode.airfryer;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.MotorDirections;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.devmode.core.BaseDevMode;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;

/**
 * @author marco
 * @date 2024/3/27 下午5:30
 */
public class AfSpecialDiyMode extends BaseDevMode {


    private boolean startCount = false;

    public AfSpecialDiyMode(){

        this.setMode(WorkModes.AF_SPECIAL_DIY_MODE);


        //温度
        this.setDefaultTemp(0);
        this.setMinTemp(0);
        this.setMaxTemp(200);

        //时间
        this.setMinTime(0);
        this.setMaxTime(60 * 60);
        this.setDefaultTime(0);
        this.setTimeChange(true);

        //电机
        this.setDefaultMotorGear(0);
        this.setMaxMotorGear(0);
        this.setMaxMotorGear(0);
        this.setMotorGearChange(false);
        this.setMotorDirectionChange(false);
        this.setMotorDirection(MotorDirections.FORWARD);



    }


    @Override
    public void start() {
        this.startCount = false;
        super.start();
    }

    @Override
    public void stop() {
        this.startCount = false;
        super.stop();
    }

    @Override
    public boolean startCountTime() {

        if(this.startCount){
            return this.startCount;
        }

        if(CofarSDK.devInfo().getTemp() >= CofarSDK.devInfo().getTargetTemp()){
            this.startCount = true;
            return this.startCountTime();
        }else{
            return false;
        }


    }

}
