package com.kuyuntech.cofarcooking.device.sdk.devmode.core;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.HeatModes;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.MotorDirections;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@EqualsAndHashCode(callSuper = true)
@Data
@ToString
public class Kettle extends BaseDevMode{

    private Long time = 0L;

    public Kettle(){

        this.setMode(WorkModes.KETTLE);


        //时间
        this.setCountDown(false);
        this.setTimeChange(false);
        this.setCountDown(false);

        //电机
        this.setDefaultMotorGear(1);
        this.setMaxMotorGear(1);
        this.setMinMotorGear(0);
        this.setMotorGearChange(true);
        this.setMotorDirectionChange(true);
        this.setMotorDirection(MotorDirections.REVERSE);

        //温度
        this.setDefaultTemp(100);
        this.setMinTemp(100);
        this.setMaxTemp(100);
        this.setTempChange(false);
        this.setDefaultHeatMode(HeatModes.SAP_SHUI);
    }


    @Override
    public boolean canStop() {

        if(CofarSDK.devInfo().getTemp() >= 100 && time == 0){
            time = System.currentTimeMillis();
        }

        return CofarSDK.devInfo().getTemp() >= 100 && (System.currentTimeMillis() - time) >= 30 * 100;

    }
}
