package com.kuyuntech.cofarcooking.device.sdk.devmode.core;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.HeatModes;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@EqualsAndHashCode(callSuper = true)
@Data
@ToString
public class Steam extends BaseDevMode{

    public Steam(){

        this.setMode(WorkModes.STEAM);


        //时间
        this.setMinTime(60 * 1);
        this.setMaxTime(60 * 60);
        this.setDefaultTime(20 * 60);
        this.setTimeChange(true);
        this.setSupportCountUp(false);

        //电机
        this.setDefaultMotorGear(0);
        this.setMinMotorGear(0);
        this.setMaxMotorGear(3);
        this.setMotorGearChange(true);
        this.setMotorDirectionChange(true);

        //温度
        this.setDefaultTemp(120);
        this.setMinTemp(100);
        this.setMaxTemp(120);
        this.setTempChange(true);
        this.setDefaultHeatMode(HeatModes.ZHENG_QI);
    }

    @Override
    public boolean startCountTime() {

        if(CofarSDK.devInfo().getTemp() >= 95){
            return super.startCountTime();
        }else{
            return false;
        }


    }
}
