package com.kuyuntech.cofarcooking.device.sdk.protocol.core.cmd;


import com.kuyuntech.cofarcooking.device.sdk.protocol.core.BaseBody;
import com.kuyuntech.cofarcooking.device.sdk.protocol.core.BaseDecoder;
import com.kuyuntech.cofarcooking.device.sdk.util.core.Converter;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@EqualsAndHashCode(callSuper = true)
@Data
@ToString
public class HeartbeatCmd extends BaseBody {

    private BaseBody baseBody;

    //指令类型
    private String cmd;

    //电机方向
    private String motorDirection;

    //电机档位
    private String motorGear;

    //是否AUTO档
    private String autoGear;

    //是否AUTO档
    private String zero;

    //加热模式
    private String heatMode;

    //当前温度
    private String temp;

    //设置目标问题
    private String targetTemp;

    //剩下时长
    private String remainTime;

    //设定时长
    private String targetTime;

    //锅状态
    private String potStatus;

    //锅盖状态
    private String potCloverStatus;

    //故障代码
    private String errCode;

    //置零
    private String resetZero;

    //当前运行状态
    private String runningStatus;

    //锅盖电磁阀状态
    private String potCloverEleStatus;

    //锅盖类型
    private String potCoverType;

    //是否支持喷水
    private String  supportWaterSpray;

    //喷水档位
    private String waterSprayGear;

    public HeartbeatCmd(String data){
        this(new BaseDecoder(data));
    }

    public HeartbeatCmd(BaseDecoder baseDecoder) {
        this.baseBody = baseDecoder.getBaseBody();
        byte[] content = this.baseBody.getContent();
        int i = 0;
        this.cmd = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.motorDirection = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.motorGear = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.autoGear = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.heatMode = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.zero = Converter.bytesToHexString(new byte[]{content[i++]},1);

        //TODO sdk临时处理
        this.zero = this.heatMode;

        this.temp = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.targetTemp = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.remainTime = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.targetTime = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.potStatus = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.potCloverStatus = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.errCode = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.resetZero = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.runningStatus = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.potCloverEleStatus = Converter.bytesToHexString(new byte[]{content[i++]},1);

        if(content.length == (i + 3)){
            this.potCoverType = Converter.bytesToHexString(new byte[]{content[i++]},1);
            this.supportWaterSpray = Converter.bytesToHexString(new byte[]{content[i++]},1);
            this.waterSprayGear = Converter.bytesToHexString(new byte[]{content[i]},1);
        }





    }

}
